#!/usr/bin/perl -w

$sigNum=4;
$preSigNum=2;
$SigNum=$sigNum+$preSigNum;
$PLAY_COMMAND="play";
$wavDir=$ENV{"LISTENINGTESTDIR"}."/wav";

@sigList = ("",
wav1,
wav2,
wav3,
wav4
);


open(NUMBERS, "test1numbers.asc") or die "Can't open randomnumber file: $!\n";
open(RES_FILE, ">> test1.dat") or die "Can't open output file: $!\n";

foreach $sig (1..$sigNum) {
    if(defined($Vec[$sig] = <NUMBERS>))
    {chomp($Vec[$sig]);}
    else
    {print "error\n";}
}

system 'clear';

print "This is an automated listining test.
You will hear $SigNum wavs.
Please judge each wav.\n";

do {
    print "please enter your sex (f=female, m=male):\n";
    print "Sex: ";
    $sex = <STDIN>;
    chop($sex);
} while ($sex ne "m" && $sex ne "f");
$age = 0;
do {
    print "please enter your age:\n";
    print "Age: ";
    $age = <STDIN>;
    chop($age);
} while ($age < 8  ||  $age > 90);

print "To launch the test, please enter <Return>. You will then hear the first wav";
<>;

system 'clear';

$satzCnt=1;
# play the last signals in front to get the listener accustomed
for ($i=$sigNum; $i > $sigNum-$preSigNum; $i--) {
    $num = $Vec[$i];
    $sig = "$wavDir/$sigList[$num].wav";
# comment this and uncomment next line to play wavs
    print $sig."\n";
    #`$PLAY_COMMAND $sig`;
    $judgement1 = "dontknow";
    $judgement2 = "dontknow";
    until ($judgement1 eq "W" or $judgement1 eq "w" or $judgement1 eq "F" or $judgement1 eq "f" or  $judgement1 eq "A" or $judgement1 eq "a" or $judgement1 eq "T" or $judgement1 eq "t" or $judgement1 eq "N" or $judgement1 eq "n" or $judgement1 eq "L" or $judgement1 eq "l"or $judgement1 eq "E" or $judgement1 eq "e")
    {
	print "\nDo You judge wav no. ".$satzCnt." as:\n\n\tw:Wut/Aerger,\tf:Freude,\te:Ekel,\t\tt:Trauer,\n\n\ta:Angst,\tl:Langeweile,\tn:Neutral?\n\n";
	print "Answer: ";
	$judgement1 = <STDIN>;
	chop($judgement1);

    }
    until ($judgement2 eq "1" or $judgement2 eq "0")
    {
	print "\nFurther judgement, did you like it?\n(1=yes, 0=no)\n\n";
	print "Answer: ";
	$judgement2 = <STDIN>;
	chop($judgement2);
    }
    $satzCnt = $satzCnt+1;
    system 'clear';
}

$Results1[0] = "dummy";
$Results2[0] = "dummy";
for ($i=1; $i <= $sigNum; $i++) {
    $num = $Vec[$i];
    $sig = "$wavDir/$sigList[$num].wav";
# comment this and uncomment next line to play wavs
    print $sig."\n";
    #`$PLAY_COMMAND $sig`;
    $judgement1 = "dontknow";
    $judgement2 = "dontknow";
    until ($judgement1 eq "W" or $judgement1 eq "w" or $judgement1 eq "F" or $judgement1 eq "f" or  $judgement1 eq "A" or $judgement1 eq "a" or $judgement1 eq "T" or $judgement1 eq "t" or $judgement1 eq "N" or $judgement1 eq "n" or $judgement1 eq "L" or $judgement1 eq "l"or $judgement1 eq "E" or $judgement1 eq "e")
    {
	print "\nDo You judge wav no. ".$satzCnt." as:\n\n\tw:Wut/Aerger,\tf:Freude,\te:Ekel,\t\tt:Trauer,\n\n\ta:Angst,\tl:Langeweile,\tn:Neutral?\n\n";
	print "Answer: ";
	$judgement1 = <STDIN>;
	chop($judgement1);
	$Results1[$Vec[$i]] = $judgement1;

    }
    until ($judgement2 eq "1" or $judgement2 eq "0")
    {
	print "\nFurther judgement, did you like it?\n(1=yes, 0=no)\n\n";
	print "Answer: ";
	$judgement2 = <STDIN>;
	chop($judgement2);
	$Results2[$Vec[$i]] = $judgement2;
    }
    system 'clear';
    $satzCnt = $satzCnt+1;
}
print("This was the last wav, thanks for participation!\n");
print RES_FILE $sex." ".$age." ";
for ($i=1; $i<=$sigNum;$i++) {
    print RES_FILE $Results1[$i]." ".$Results2[$i]." ";
}
print RES_FILE "\n";
